package main;

public class Alarm
{
    private Sensor sensor = null;
    private Policy policy = null;

    private boolean alarmOn = false;

	public Alarm(Sensor sensor, Policy policy) {
		super();
		this.sensor = sensor;
		this.policy = policy;
	}

	public void checkAlarm()
    {
		if ((policy != null) && (sensor != null)) {
			alarmOn = policy.checkPolicyViolated(sensor.popNextValue());
		} else {
			throw new IllegalStateException("Sensor or Policy missing!");
		}
    }

    public boolean isAlarmOn()
    {
        return alarmOn; 
    }

	public void setPolicy(Policy policy) {
		this.policy = policy;
	}
	
	public void setSensor(Sensor sensor) {
		this.sensor = sensor;
	}

}
