package test;
import main.Alarm;
import main.LowAndHighPolicy;
import main.Policy;
import main.Sensor;

import org.junit.*;

import static org.junit.Assert.*;

public class TestAlarm {

    private double lowPressureTreshold = 17;
	private double highPressureTreshold = 21;
	private double offset = 16;

	Alarm alarm;
	Policy policy;
	MockSensor mockSensor;
	
    @Before
    public void setup() {
    	policy = new LowAndHighPolicy(lowPressureTreshold, highPressureTreshold);
        mockSensor = new MockSensor(offset);
        alarm = new Alarm(mockSensor, policy);
    }
    
    @Test
    public void testPressureBelowMin() {
        double pressure = 8.0d - mockSensor.getOffset();
        mockSensor.setValue(pressure);
        alarm.setSensor(mockSensor);
        alarm.checkAlarm();
        assertTrue(alarm.isAlarmOn());
    }
    
    @Test
    public void testPressureAboveMax() {
        double pressure = 25.0d - mockSensor.getOffset();
        mockSensor.setValue(pressure);
        alarm.setSensor(mockSensor);
        alarm.checkAlarm();
        assertTrue(alarm.isAlarmOn());
    }
    @Test
    public void testPressureOk() {
        double pressure = 19.0d - mockSensor.getOffset();
        mockSensor.setValue(pressure);
        alarm.setSensor(mockSensor);
        alarm.checkAlarm();
        assertFalse(alarm.isAlarmOn());
    }
}